package com.ruoyi.zhdd.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.ruoyi.common.core.mybatisplus.core.ServicePlusImpl;
import com.ruoyi.common.core.page.PagePlus;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.utils.PageUtils;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.zhdd.domain.PlanFile;
import com.ruoyi.zhdd.domain.PlanTask;
import com.ruoyi.zhdd.domain.bo.PlanFileBo;
import com.ruoyi.zhdd.domain.bo.PlanTaskBo;
import com.ruoyi.zhdd.domain.vo.PlanFileVo;
import com.ruoyi.zhdd.domain.vo.PlanTaskVo;
import com.ruoyi.zhdd.mapper.PlanFileMapper;
import com.ruoyi.zhdd.mapper.PlanTaskMapper;
import com.ruoyi.zhdd.service.IPlanFileService;
import com.ruoyi.zhdd.service.IPlanTaskService;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 预案任务管理Service业务层处理
 *
 * @author xitong
 * @date 2021-09-28
 */
@Service
public class PlanFileServiceImpl extends ServicePlusImpl<PlanFileMapper, PlanFile, PlanFileVo> implements IPlanFileService {

    @Override
    public PlanFileVo queryById(String id){
        return getVoById(id);
    }

    @Override
    public TableDataInfo<PlanFileVo> queryPageList(PlanFileBo bo) {
        PagePlus<PlanFile, PlanFileVo> result = pageVo(PageUtils.buildPagePlus(), buildQueryWrapper(bo));
        return PageUtils.buildDataInfo(result);
    }

    @Override
    public List<PlanFileVo> queryList(PlanFileBo bo) {
        return listVo(buildQueryWrapper(bo));
    }

    private LambdaQueryWrapper<PlanFile> buildQueryWrapper(PlanFileBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<PlanFile> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getPlanId() != null, PlanFile::getPlanId, bo.getPlanId());
        lqw.like(StringUtils.isNotBlank(bo.getFileName()), PlanFile::getFileName, bo.getFileName());
        lqw.eq(StringUtils.isNotBlank(bo.getFileUrl()), PlanFile::getFileUrl, bo.getFileUrl());
        return lqw;
    }

    @Override
    public Boolean insertByBo(PlanFileBo bo) {
        PlanFile add = BeanUtil.toBean(bo, PlanFile.class);
        validEntityBeforeSave(add);
        return save(add);
    }

    @Override
    public Boolean updateByBo(PlanFileBo bo) {
        PlanFile update = BeanUtil.toBean(bo, PlanFile.class);
        validEntityBeforeSave(update);
        return updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(PlanFile entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<String> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return removeByIds(ids);
    }
}
